VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BrowseForFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"BrowseForFolder"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'local variable(s) to hold property value(s)
Private mvarPath As String        'local copy
Private mvarDisplayName As String   'local copy
Private mvarRootDirectory As eRootDirectory 'local copy
Private mvarFlags As eBrowseFlag    'local copy
Private mvarInitDir As String 'local copy

Public Enum eBrowseFlag
    BIF_RETURNONLYFSDIRS = &H1      ' For finding a folder to start document searching
    BIF_DONTGOBELOWDOMAIN = &H2     ' For starting the Find Computer
    BIF_STATUSTEXT = &H4
    BIF_RETURNFSANCESTORS = &H8
    BIF_EDITBOX = &H10
    BIF_VALIDATE = &H20             ' insist on valid result (or CANCEL)
    
    BIF_BROWSEFORCOMPUTER = &H1000  'Browsing for Computers.
    BIF_BROWSEFORPRINTER = &H2000   'Browsing for Printers
    BIF_BROWSEINCLUDEFILES = &H4000 'Browsing for Everything
    
End Enum

Public Enum eRootDirectory
    DESKTOP = &H0
    INTERNET = &H1
    PROGRAMS = &H2
    DirControls = &H3
    dirPrinters = &H4
    PERSONAL = &H5
    FAVORITES = &H6
    STARTUP = &H7
    RECENT = &H8
    SENDTO = &H9
    BITBUCKET = &HA
    STARTMENU = &HB
    DESKTOPDIRECTORY = &H10
    DRIVES = &H11
    NETWORK = &H12
    NETHOOD = &H13
    DirFonts = &H14
    TEMPLATES = &H15
    COMMON_STARTMENU = &H16
    COMMON_PROGRAMS = &H17
    COMMON_STARTUP = &H18
    COMMON_DESKTOPDIRECTORY = &H19
    APPDATA = &H1A
    PRINTHOOD = &H1B
    ALTSTARTUP = &H1D                          ' DBCS
    COMMON_ALTSTARTUP = &H1E                   ' DBCS
    COMMON_FAVORITES = &H1F
    INTERNET_CACHE = &H20
    COOKIES = &H21
    HISTORY = &H22
End Enum
Public Property Let InitDir(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.InitDir = 5
    mvarInitDir = vData
End Property


Public Property Get InitDir() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.InitDir
    InitDir = mvarInitDir
End Property




Public Function BrowseForFolder(hwndOwner As Long, sPrompt As String) As Boolean
    On Error GoTo ERROR_BrowseForFolder

Dim sPath As String, sDisplayName As String

    BrowseForFolder = BrowseForFolderEx(hwndOwner, sPrompt, RootDirectory, _
                                        InitDir, Flags, _
                                        sPath, sDisplayName)
    Path = sPath
    DisplayName = sDisplayName

EXIT_BrowseForFolder:
    Exit Function

ERROR_BrowseForFolder:
    Err.Raise Err.Number, Err.Source, Err.Description
    Resume EXIT_BrowseForFolder

End Function

Public Property Let Flags(ByVal vData As eBrowseFlag)
    mvarFlags = vData
End Property

Public Property Get Flags() As eBrowseFlag
    Flags = mvarFlags
End Property

Public Property Let RootDirectory(ByVal vData As eRootDirectory)
    mvarRootDirectory = vData
End Property

Public Property Get RootDirectory() As eRootDirectory
    RootDirectory = mvarRootDirectory
End Property

Public Property Get Path() As String
        Path = mvarPath
End Property

Private Property Let Path(ByVal vData As String)
    mvarPath = vData
End Property

Public Property Get DisplayName() As String
    DisplayName = mvarDisplayName
End Property

Private Property Let DisplayName(ByVal vData As String)
    mvarDisplayName = vData
End Property





